package io.zipcoder.crudapp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

@RestController
public class PersonController{

//    @Autowired
//    PersonService personService;
    @Autowired
    PersonRepository personRepository;

    //  var URI = "http://localhost:8080/people/";
    @PostMapping("/people")
    Person createPerson(@RequestBody Person person){ //(Person p)
        personRepository.save(person);
        return person;
    }

    @GetMapping("/people/{id}")
    Person getPerson(@PathVariable int id){
        int newId = id;
        return personRepository.findOne(newId);
    }

    @GetMapping("/people")
    List<Person> getPersonList(){
        List<Person> list = StreamSupport
                .stream(
                        personRepository
                                .findAll()
                                .spliterator(), false
                )
                .collect(Collectors.toList());
        return list;
    }

    @PostMapping("/people/{id}")
    Person updatePerson(Person p){
        Person newPerson = personRepository.findOne(p.getId());
        newPerson = p;
        return p;
    }

    @DeleteMapping("/people{id}")
    void deletePerson(@PathVariable int id){
        personRepository.delete(id);
    }
}
/*
POST /people - create a new person
Response: 201 Created
GET /people - get the list of all people
Response: 200 OK
GET /people/{id} - Get the person with id number {id}
Response: 200 OK if found, else 404 Not Found
PUT /people/{id} - Update the person with id number {id}
Response: 200 OK if updated, 201 Created if a new entity was created
DELETE /people/{id} - delete the person with id number {id}
Response: 204 No Content

# Enabling H2 Console
spring.h2.console.enabled=true
 */